<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.2                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2004 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: TestOfTableCore.php 999 2004-11-25 14:59:05Z andrew $
*/

/**
 * @package    MaxDal
 * @subpackage TestSuite
 * @author     Andrew Hill <andrew@awarez.net>
 */

require_once maintenancePath . '/maintenance-common.php';
require_once maintenancePath . '/libraries/max/Dal/TableCore.php';
require_once maintenancePath . '/libraries/pear/Log.php';

/**
 * A class for testing the Dal_Table_Core class.
 */
class Dal_TestOfTableCore extends UnitTestCase
{
    
    /**
     * The constructor method.
     */
    function Dal_TestOfTableCore()
    {        
        $this->UnitTestCase();
    }
    
    /**
     * Tests that the singleton() method only ever returns one
     * class instance.
     */
    function testSingleton()
    {
        debug('Running test', PEAR_LOG_INFO);
        $first =& Dal_Table_Core::singleton();
        $second =& Dal_Table_Core::singleton();
        $this->assertIdentical($first, $second);
    }
    
    /**
     * Tests creating/dropping all of the core tables.
     */
    function testAllCoreTables()
    {
        debug('Running test', PEAR_LOG_INFO);
        $conf =& $GLOBALS['_MAX']['CONF'];
        $tables =& Dal_Table_Core::singleton();
        $dal =& Dal::singleton();
        // Create with split mode off
        $conf['table']['split'] = false;
        // Table: acls
        $tables->createTable('acls');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['acls']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['acls']);
        // Table: affiliates
        $tables->createTable('affiliates');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['affiliates']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['affiliates']);
        // Table: agency
        $tables->createTable('agency');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['agency']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['agency']);
        // Table: application_variable
        $tables->createTable('application_variable');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['application_variable']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['application_variable']);
        // Table: banners
        $tables->createTable('banners');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['banners']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['banners']);
        // Table: cache
        $tables->createTable('cache');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['cache']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['cache']);
        // Table: campaigns
        $tables->createTable('campaigns');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['campaigns']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['campaigns']);
        // Table: campaigns_trackers
        $tables->createTable('campaigns_trackers');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['campaigns_trackers']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['campaigns_trackers']);
        // Table: clients
        $tables->createTable('clients');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['clients']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['clients']);
        // Table: config
        $tables->createTable('config');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['config']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['config']);
        // Table: data_intermediate_ad
        $tables->createTable('data_intermediate_ad');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_intermediate_ad']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_intermediate_ad']);
        // Table: data_intermediate_ad_connection
        $tables->createTable('data_intermediate_ad_connection');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_intermediate_ad_connection']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_intermediate_ad_connection']);
        // Table: data_intermediate_ad_variable_value
        $tables->createTable('data_intermediate_ad_variable_value');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_intermediate_ad_variable_value']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_intermediate_ad_variable_value']);
        // Table: data_raw_ad_click
        $tables->createTable('data_raw_ad_click');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_raw_ad_click']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_raw_ad_click']);
        // Table: data_raw_ad_impression
        $tables->createTable('data_raw_ad_impression');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_raw_ad_impression']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_raw_ad_impression']);
        // Table: data_raw_ad_request
        $tables->createTable('data_raw_ad_request');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_raw_ad_request']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_raw_ad_request']);
        // Table: data_raw_tracker_click
        $tables->createTable('data_raw_tracker_click');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_raw_tracker_click']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_raw_tracker_click']);
        // Table: data_raw_tracker_impression
        $tables->createTable('data_raw_tracker_impression');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_raw_tracker_impression']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_raw_tracker_impression']);
        // Table: data_raw_tracker_variable_value
        $tables->createTable('data_raw_tracker_variable_value');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_raw_tracker_variable_value']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_raw_tracker_variable_value']);
        // Table: data_summary_ad_hourly
        $tables->createTable('data_summary_ad_hourly');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_summary_ad_hourly']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_summary_ad_hourly']);
        // Table: data_summary_zone_impression_history
        $tables->createTable('data_summary_zone_impression_history');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_summary_zone_impression_history']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_summary_zone_impression_history']);
        // Table: images
        $tables->createTable('images');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['images']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['images']);
        // Table: log_maintenance
        $tables->createTable('log_maintenance');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['log_maintenance']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['log_maintenance']);
        // Table: log_maintenance_statistics
        $tables->createTable('log_maintenance_statistics');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['log_maintenance_statistics']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['log_maintenance_statistics']);
        // Table: session
        $tables->createTable('session');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['session']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['session']);
        // Table: targetstats
        $tables->createTable('targetstats');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['targetstats']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['targetstats']);
        // Table: trackers
        $tables->createTable('trackers');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['trackers']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['trackers']);
        // Table: userlog
        $tables->createTable('userlog');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['userlog']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['userlog']);
        // Table: variables
        $tables->createTable('variables');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['variables']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['variables']);
        // Table: zones
        $tables->createTable('zones');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['zones']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['zones']);
        // Create with split mode on
        $now = new Date();
        $conf['table']['split'] = true;
        // Table: acls
        $tables->createTable('acls');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['acls']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['acls']);
        // Table: affiliates
        $tables->createTable('affiliates');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['affiliates']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['affiliates']);
        // Table: agency
        $tables->createTable('agency');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['agency']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['agency']);
        // Table: application_variable
        $tables->createTable('application_variable');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['application_variable']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['application_variable']);
        // Table: banners
        $tables->createTable('banners');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['banners']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['banners']);
        // Table: cache
        $tables->createTable('cache');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['cache']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['cache']);
        // Table: campaigns
        $tables->createTable('campaigns');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['campaigns']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['campaigns']);
        // Table: campaigns_trackers
        $tables->createTable('campaigns_trackers');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['campaigns_trackers']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['campaigns_trackers']);
        // Table: clients
        $tables->createTable('clients');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['clients']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['clients']);
        // Table: config
        $tables->createTable('config');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['config']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['config']);
        // Table: data_intermediate_ad
        $tables->createTable('data_intermediate_ad');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_intermediate_ad']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_intermediate_ad']);
        // Table: data_intermediate_ad_connection
        $tables->createTable('data_intermediate_ad_connection');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_intermediate_ad_connection']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_intermediate_ad_connection']);
        // Table: data_intermediate_ad_variable_value
        $tables->createTable('data_intermediate_ad_variable_value');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_intermediate_ad_variable_value']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_intermediate_ad_variable_value']);
        // Table: data_raw_ad_click
        $tables->createTable('data_raw_ad_click');
        $table = $conf['table']['data_raw_ad_click'] . '_' . $now->format('%Y%m%d');
        $query = "SELECT COUNT(*) AS number FROM $table";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($table);
        // Table: data_raw_ad_impression
        $tables->createTable('data_raw_ad_impression');
        $table = $conf['table']['data_raw_ad_impression'] . '_' . $now->format('%Y%m%d');
        $query = "SELECT COUNT(*) AS number FROM $table";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($table);
        // Table: data_raw_ad_request
        $tables->createTable('data_raw_ad_request');
        $table = $conf['table']['data_raw_ad_request'] . '_' . $now->format('%Y%m%d');
        $query = "SELECT COUNT(*) AS number FROM $table";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($table);
        // Table: data_raw_tracker_click
        $tables->createTable('data_raw_tracker_click');
        $table = $conf['table']['data_raw_tracker_click'] . '_' . $now->format('%Y%m%d');
        $query = "SELECT COUNT(*) AS number FROM $table";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($table);
        // Table: data_raw_tracker_impression
        $tables->createTable('data_raw_tracker_impression');
        $table = $conf['table']['data_raw_tracker_impression'] . '_' . $now->format('%Y%m%d');
        $query = "SELECT COUNT(*) AS number FROM $table";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($table);
        // Table: data_raw_tracker_variable_value
        $tables->createTable('data_raw_tracker_variable_value');
        $table = $conf['table']['data_raw_tracker_variable_value'] . '_' . $now->format('%Y%m%d');
        $query = "SELECT COUNT(*) AS number FROM $table";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($table);
        // Table: data_summary_ad_hourly
        $tables->createTable('data_summary_ad_hourly');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_summary_ad_hourly']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_summary_ad_hourly']);
        // Table: data_summary_zone_impression_history
        $tables->createTable('data_summary_zone_impression_history');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['data_summary_zone_impression_history']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['data_summary_zone_impression_history']);
        // Table: images
        $tables->createTable('images');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['images']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['images']);
        // Table: log_maintenance
        $tables->createTable('log_maintenance');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['log_maintenance']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['log_maintenance']);
        // Table: log_maintenance_statistics
        $tables->createTable('log_maintenance_statistics');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['log_maintenance_statistics']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['log_maintenance_statistics']);
        // Table: session
        $tables->createTable('session');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['session']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['session']);
        // Table: targetstats
        $tables->createTable('targetstats');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['targetstats']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['targetstats']);
        // Table: trackers
        $tables->createTable('trackers');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['trackers']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['trackers']);
        // Table: userlog
        $tables->createTable('userlog');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['userlog']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['userlog']);
        // Table: variables
        $tables->createTable('variables');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['variables']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['variables']);
        // Table: zones
        $tables->createTable('zones');
        $query = "SELECT COUNT(*) AS number FROM {$conf['table']['zones']}";
        $dal->execute($query, $result);
        $row = mysql_fetch_array($result);
        $this->assertEqual($row['number'], 0);
        $tables->dropTable($conf['table']['zones']);
    }
    
}

?>